
Func Vec3f($x, $y, $z)
	Local $v = [$x, $y, $z]
	Return $v
EndFunc

Func Vec3fCopy($v) ; Jesus.... warum hab ich diese Funktion geschrieben? Structs? Vergessen...
	Return $v
EndFunc

Func Vec3fRefAdd(ByRef $a, ByRef $b)
	$a[0] += $b[0]
	$a[1] += $b[1]
	$a[2] += $b[2]
EndFunc

Func Vec3fAdd($a, ByRef $b)
	$a[0] += $b[0]
	$a[1] += $b[1]
	$a[2] += $b[2]
	Return $a
EndFunc

Func Vec3fRefSub(ByRef $a, ByRef $b)
	$a[0] -= $b[0]
	$a[1] -= $b[1]
	$a[2] -= $b[2]
EndFunc

Func Vec3fSub($a, ByRef $b)
	$a[0] -= $b[0]
	$a[1] -= $b[1]
	$a[2] -= $b[2]
	Return $a
EndFunc

Func Vec3fRefScalarMul(ByRef $a, ByRef $b)
	$a[0] *= $b
	$a[1] *= $b
	$a[2] *= $b
EndFunc

Func Vec3fScalarMul($a, ByRef $b)
	$a[0] *= $b
	$a[1] *= $b
	$a[2] *= $b
	Return $a
EndFunc

Func Vec3fRefScalarDiv(ByRef $a, ByRef $b)
	$a[0] /= $b
	$a[1] /= $b
	$a[2] /= $b
EndFunc

Func Vec3fScalarDiv($a, $b)
	$a[0] /= $b
	$a[1] /= $b
	$a[2] /= $b
	Return $a
EndFunc

Func Vec3fScalarProduct(ByRef $a, ByRef $b)
	Return $a[0] * $b[0] + $a[1] * $b[1] + $a[2] * $b[2]
EndFunc

Func Vec3fLen(ByRef $a)
	Return Sqrt($a[0] * $a[0] + $a[1] * $a[1] + $a[2] * $a[2])
EndFunc

Func Vec3fRefNorm(ByRef $a)
	Local $l = Sqrt($a[0] * $a[0] + $a[1] * $a[1] + $a[2] * $a[2])
	$a[0] /= $l
	$a[1] /= $l
	$a[2] /= $l
EndFunc

Func Vec3fNorm($a)
	Local $l = Sqrt($a[0] * $a[0] + $a[1] * $a[1] + $a[2] * $a[2])
	$a[0] /= $l
	$a[1] /= $l
	$a[2] /= $l
	Return $a
EndFunc

Func Vec3fRefCross(ByRef $a, ByRef $b)
	Local $c = [$a[1] * $b[2] - $a[2] * $b[1], $a[2] * $b[0] - $a[0] * $b[2], $a[0] * $b[1] - $a[1] * $b[0]]
	$a = $c
EndFunc

Func Vec3fCross($a, $b)
	Local $c = [$a[1] * $b[2] - $a[2] * $b[1], $a[2] * $b[0] - $a[0] * $b[2], $a[0] * $b[1] - $a[1] * $b[0]]
	Return $c
EndFunc

Func Vec3fCrossTriangleNorm(ByRef $a, ByRef $b, ByRef $c, $f)
	Local $n = [($a[1] - $b[1]) * ($a[2] - $c[2]) - ($a[2] - $b[2]) * ($a[1] - $c[1]), ($a[2] - $b[2]) * ($a[0] - $c[0]) - ($a[0] - $b[0]) * ($a[2] - $c[2]), ($a[0] - $b[0]) * ($a[1] - $c[1]) - ($a[1] - $b[1]) * ($a[0] - $c[0])], $l = $f/Sqrt($a[0] * $a[0] + $a[1] * $a[1] + $a[2] * $a[2])
	$n[0] *= $l
	$n[1] *= $l
	$n[2] *= $l
	Return $n
EndFunc

Func Vec3fCrossTriangle(ByRef $a, ByRef $b, ByRef $c)
	Local $n = [($a[1] - $b[1]) * ($a[2] - $c[2]) - ($a[2] - $b[2]) * ($a[1] - $c[1]), ($a[2] - $b[2]) * ($a[0] - $c[0]) - ($a[0] - $b[0]) * ($a[2] - $c[2]), ($a[0] - $b[0]) * ($a[1] - $c[1]) - ($a[1] - $b[1]) * ($a[0] - $c[0])]
	Return $n
EndFunc

Func Vec3fCenterTriangle(ByRef $a, ByRef $b, ByRef $c)
	Local $m = [($a[0] + $b[0] + $c[0])/3, ($a[1] + $b[1] + $c[1])/3, ($a[2] + $b[2] + $c[2])/3]
	Return $m
EndFunc